searchData={"items":[{"type":"module","title":"dockerexec","doc":"OS shell command runner. It communicates with a separate C++ port process exec-port spawned by this module, which is responsible for starting, killing, listing, terminating, and notifying of state changes. The port program serves as a middle-man between the OS and the virtual machine to carry out OS-specific low-level process control. The Erlang/C++ protocol is described in the exec.cpp file. The dockerexec application can execute tasks by impersonating as a different effective user. This impersonation can be accomplished in one of the following two ways (assuming that the emulator is not running as root : Having the user account running the erlang emulator added to the /etc/sudoers file, so that it can execute exec-port task as root . (Preferred option) Setting root ownership on exec-port , and setting the SUID bit: chown root:root exec-port; chmod 4755 exec-port . (This option is discouraged as it's less secure). In either of these two cases, dockerexec:start_link/2 must be started with options [root, {user, User}, {limit_users, Users}] , so that exec-port process will not actually run as root but will switch to the effective User , and set the kernel capabilities so that it's able to start processes as other effective users given in the Users list and adjust process priorities. Though, in the initial design, exec prohibited such use, upon user requests a feature was added (in order to support docker deployment and CI testing) to be able to execute exec-port as root without switching the effective user to anying other than root . To accomplish this use the following options to start dockerexec : [root, {user, &quot;root&quot;}, {limit_users, [&quot;root&quot;]}] . At exit the port program makes its best effort to perform clean shutdown of all child OS processes. Every started OS process is linked to a spawned light-weight Erlang process returned by the run/2, run_link/2 command. The application ensures that termination of spawned OsPid leads to termination of the associated Erlang Pid, and vice versa.","ref":"dockerexec.html"},{"type":"function","title":"dockerexec.debug/1","doc":"Set debug level of the port process.","ref":"dockerexec.html#debug/1"},{"type":"function","title":"dockerexec.kill/2","doc":"Send a Signal to a child Pid , OsPid or an Erlang Port .","ref":"dockerexec.html#kill/2"},{"type":"function","title":"dockerexec.manage/2","doc":null,"ref":"dockerexec.html#manage/2"},{"type":"function","title":"dockerexec.ospid/1","doc":"Get OsPid of the given Erlang Pid . The Pid must be created previously by running the run/2 or run_link/2 commands.","ref":"dockerexec.html#ospid/1"},{"type":"function","title":"dockerexec.pid/1","doc":"Get Pid of the given OsPid . The OsPid must be created previously by running the run/2 or run_link/2 commands.","ref":"dockerexec.html#pid/1"},{"type":"function","title":"dockerexec.pty_opts/2","doc":"Set the pty terminal options of the OS process identified by OsPid . The process must have been created with the pty option.","ref":"dockerexec.html#pty_opts/2"},{"type":"function","title":"dockerexec.run/2","doc":null,"ref":"dockerexec.html#run/2"},{"type":"function","title":"dockerexec.run/3","doc":"Run an external program. OsPid is the OS process identifier of the new process. If sync is specified in Options the return value is {ok, Status} where Status is OS process exit status. The Status can be decoded with status/1 to determine the process's exit code and if it was killed by signal.","ref":"dockerexec.html#run/3"},{"type":"function","title":"dockerexec.run_link/2","doc":null,"ref":"dockerexec.html#run_link/2"},{"type":"function","title":"dockerexec.run_link/3","doc":"Equivalent to run / 2. Run an external program and link to the OsPid. If OsPid exits, the calling process will be killed or if it's trapping exits, it'll get {'EXIT', OsPid, Status} message. If the calling process dies the OsPid will be killed. The Status can be decoded with status/1 to determine the process's exit code and if it was killed by signal.","ref":"dockerexec.html#run_link/3"},{"type":"function","title":"dockerexec.send/2","doc":"Send Data to stdin of the OS process identified by OsPid . Sending eof instead of binary Data causes close of stdin of the corresponding process. Data sent to closed stdin is ignored.","ref":"dockerexec.html#send/2"},{"type":"function","title":"dockerexec.setpgid/2","doc":"Change group ID of a given OsPid to Gid .","ref":"dockerexec.html#setpgid/2"},{"type":"function","title":"dockerexec.signal/1","doc":"Convert a signal number to atom","ref":"dockerexec.html#signal/1"},{"type":"function","title":"dockerexec.signal_to_int/1","doc":null,"ref":"dockerexec.html#signal_to_int/1"},{"type":"function","title":"dockerexec.start/0","doc":"Equivalent to start_link / 1. Start of an external program manager without supervision. Note that the port program defaults to using /bin/sh` to execute, but you can use the `SHELL environment variable to override that.","ref":"dockerexec.html#start/0"},{"type":"function","title":"dockerexec.start/1","doc":null,"ref":"dockerexec.html#start/1"},{"type":"function","title":"dockerexec.start_link/1","doc":"Supervised start an external program manager. Note that the port program defaults to using /bin/sh` to execute, but you can use the `SHELL environment variable to override that.","ref":"dockerexec.html#start_link/1"},{"type":"function","title":"dockerexec.status/1","doc":"Decode the program's exit_status. If the program exited by signal the function returns {signal, Signal, Core} where the Signal is the signal number or atom, and Core indicates if the core file was generated.","ref":"dockerexec.html#status/1"},{"type":"function","title":"dockerexec.stop/1","doc":"Terminate a managed Pid , OsPid , or Port process. The OS process is terminated gracefully. If it was given a {kill, Cmd} option at startup, that command is executed and a timer is started. If the program doesn't exit, then the default termination is performed. Default termination implies sending a SIGTERM command followed by SIGKILL in 5 seconds, if the program doesn't get killed.","ref":"dockerexec.html#stop/1"},{"type":"function","title":"dockerexec.stop_and_wait/2","doc":"Terminate a managed Pid , OsPid , or Port process, like stop/1 , and wait for it to exit.","ref":"dockerexec.html#stop_and_wait/2"},{"type":"function","title":"dockerexec.which_children/0","doc":"Get a list of children managed by port program.","ref":"dockerexec.html#which_children/0"},{"type":"function","title":"dockerexec.winsz/3","doc":"Set the pty terminal Rows and Cols of the OS process identified by OsPid . The process must have been created with the pty option.","ref":"dockerexec.html#winsz/3"},{"type":"type","title":"dockerexec.cmd/0","doc":"Command to be executed. If specified as a string, the specified command will be executed through the shell. The current shell is obtained from environment variable SHELL , falling back to /bin/sh`. This can be useful if you are using Erlang primarily for the enhanced control flow it offers over most system shells and still want convenient access to other shell features such as shell pipes, filename wildcards, environment variable expansion, and expansion of `~ to a user's home directory. All command arguments must be properly escaped including whitespace and shell metacharacters. Any part of the command string can contain unicode characters. Warning: Executing shell commands that incorporate unsanitized input from an untrusted source makes a program vulnerable to shell injection , a serious security flaw which can result in arbitrary command execution. For this reason, the use of shell is strongly discouraged in cases where the command string is constructed from external input: 1 &gt; { ok , Filename } = io : read ( &quot;Enter filename: &quot; ) . Enter filename : &quot;non_existent; rm -rf / #&quot; . { ok , &quot;non_existent; rm -rf / #&quot; } 2 &gt; dockerexec ( Filename , [ ] ) % Argh!!! This is not good! When command is given in the form of a list of strings, it is passed to execve(3) library call directly without involving the shell process, so the list of strings represents the program to be executed given with a full path, followed by the list of arguments (e.g. [&quot;/bin/echo&quot;, &quot;ok&quot;] ). In this case all shell-based features are disabled and there's no shell injection vulnerability.","ref":"dockerexec.html#t:cmd/0"},{"type":"type","title":"dockerexec.cmd_option/0","doc":"Command options: monitor Set up a monitor for the spawned process. The monitor is not a standard erlang:monitor/2 function call, but it's emulated by ensuring that the monitoring process receives notification in the form: {'DOWN', OsPid::integer(), process, Pid::pid(), Reason} . If the Reason is normal , then process exited with status 0 , otherwise there was an error. If the Reason is {status, Status} the returned Status can be decoded with status/1 to determine the exit code of the process and if it was killed by signal. sync Block the caller until the OS command exits {executable, Executable::string()} Specifies a replacement program to execute. It is very seldom needed. When the port program executes a child process using execve(3) call, the call takes the following arguments: (Executable, Args, Env) . When Cmd argument passed to the run/2 function is specified as the list of strings, the executable replaces the first parameter in the call, and the original args provided in the Cmd parameter are passed as as the second parameter. Most programs treat the program specified by args as the command name, which can then be different from the program actually executed. On Unix, the args name becomes the display name for the executable in utilities such as ps . If Cmd argument passed to the run/2 function is given as a string, on Unix the Executable specifies a replacement shell for the default /bin/sh . {cd, WorkDir} Working directory {env, Env :: [{Name,Value}|string()|clear]} List of &quot;VAR=VALUE&quot; environment variables or list of {Name, Value} tuples or strings (like &quot;NAME=VALUE&quot;) or clear . clear will clear environment of a spawned child OS process (so that it doesn't inherit parent's environment). If Value is false then the Var env variable is unset. {kill, KillCmd} This command will be used for killing the process. After a 5-sec timeout if the process is still alive, it'll be killed with SIGKILL. The kill command will have a CHILD_PID environment variable set to the pid of the process it is expected to kill. If the kill option is not specified, by default first the command is sent a SIGTERM signal, followed by SIGKILL after a default timeout. {kill_timeout, Sec::integer()} Number of seconds to wait after issuing a SIGTERM or executing the custom kill command (if specified) before killing the process with the SIGKILL signal kill_group At process exit kill the whole process group associated with this pid. The process group is obtained by the call to getpgid(3). {group, GID} Sets the effective group ID of the spawned process. The value 0 means to create a new group ID equal to the OS pid of the process. {user, RunAsUser} When exec-port was compiled with capability (Linux) support enabled and has a suid bit set, it's capable of running commands with a different RunAsUser effective user. Passing &quot;root&quot; value of RunAsUser is prohibited. {success_exit_code, IntExitCode} On success use IntExitCode return value instead of default 0. {nice, Priority} Set process priority between -20 and 20. Note that negative values can be specified only when exec-port is started with a root suid bit set. stdin | {stdin, null | close | Filename} Enable communication with an OS process via its stdin . The input to the process is sent by dockerexec:send(OsPid, Data) . When specified as a tuple, null means redirection from /dev/null , close means to close stdin stream, and Filename means to take input from file. stdout Same as {stdout, self()} . stderr Same as {stderr, self()} . {stdout, output_device()} Redirect process's standard output stream {stderr, output_device()} Redirect process's standard error stream {stdout | stderr, Filename::string(), [output_dev_opt()]} Redirect process's stdout/stderr stream to file {winsz, {Rows, Cols}} Set the (psudo) terminal's dimensions of rows and columns pty Use pseudo terminal for the process's stdin, stdout and stderr pty_echo Allow the pty to run in echo mode, disabled by default debug Same as {debug, 1} {debug, Level::integer()} Enable debug printing in port program for this command","ref":"dockerexec.html#t:cmd_option/0"},{"type":"type","title":"dockerexec.cmd_options/0","doc":null,"ref":"dockerexec.html#t:cmd_options/0"},{"type":"type","title":"dockerexec.exec_option/0","doc":"Options passed to the dockerexec process at startup. They can be specified in the sys.config file for the dockerexec application to customize application startup. debug Same as {debug, 1} {debug, Level} Enable port-programs debug trace at Level . verbose Enable verbose prints of the Erlang process. root | {root, Boolean} Allow running child processes as root. {args, Args} Append Args to the port command. {alarm, Secs} Give Secs deadline for the port program to clean up child pids before exiting {user, User} When the port program was compiled with capability (Linux) support enabled, and is owned by root with a a suid bit set, this option must be specified so that upon startup the port program is running under the effective user different from root. This is a security measure that will also prevent the port program to execute root commands. {limit_users, LimitUsers} Limit execution of external commands to these set of users. This option is only valid when the port program is owned by root. {portexe, Exe} Provide an alternative location of the port program. This option is useful when this application is stored on NFS and the port program needs to be copied locally so that root suid bit can be set. {env, Env} Extend environment of the port program by using Env specification. Env should be a list of tuples {Name, Val} , where Name is the name of an environment variable, and Val is the value it is to have in the spawned port process. If Val is false , then the Name environment variable is unset.","ref":"dockerexec.html#t:exec_option/0"},{"type":"type","title":"dockerexec.exec_options/0","doc":null,"ref":"dockerexec.html#t:exec_options/0"},{"type":"type","title":"dockerexec.osgid/0","doc":"Representation of OS group ID.","ref":"dockerexec.html#t:osgid/0"},{"type":"type","title":"dockerexec.ospid/0","doc":"Representation of OS process ID.","ref":"dockerexec.html#t:ospid/0"},{"type":"type","title":"dockerexec.output_dev_opt/0","doc":"Output device option: null Suppress output. close Close file descriptor for writing. print A debugging convenience device that prints the output to the console shell Filename Save output to file by overwriting it. pid() Redirect output to this pid. fun((Stream, OsPid, Data) -&gt; none()) Execute this callback on receiving output data","ref":"dockerexec.html#t:output_dev_opt/0"},{"type":"type","title":"dockerexec.output_file_opt/0","doc":"Defines file opening attributes: append Open the file in append mode {mode, Mode} File creation access mode specified in base 8 (e.g. 8#0644)","ref":"dockerexec.html#t:output_file_opt/0"},{"type":"type","title":"dockerexec.pty_opt/0","doc":"Pty options, see: https://man7.org/linux/man-pages/man3/termios.3.html https://datatracker.ietf.org/doc/html/rfc4254#section-8 {tty_char(), Byte} A special character with value from 0 to 255 {tty_mode(), Enable} Enable/disable a tty mode {tty_speed(), Speed} Specify input or output baud rate. Provided for completeness. Not useful for pseudo terminals.","ref":"dockerexec.html#t:pty_opt/0"},{"type":"type","title":"dockerexec.pty_opts/0","doc":"List of pty options.","ref":"dockerexec.html#t:pty_opts/0"},{"type":"type","title":"dockerexec.tty_char/0","doc":null,"ref":"dockerexec.html#t:tty_char/0"},{"type":"type","title":"dockerexec.tty_mode/0","doc":null,"ref":"dockerexec.html#t:tty_mode/0"},{"type":"type","title":"dockerexec.tty_speed/0","doc":null,"ref":"dockerexec.html#t:tty_speed/0"},{"type":"module","title":"dockerexec_app","doc":"This module implements application and supervisor behaviors of the dockerexec application.","ref":"dockerexec_app.html"},{"type":"extras","title":"Overview","doc":"# dockerexec - An erlexec fork designed for execution within Docker\n\n[![build](https://github.com/s3cur3/dockerexec/actions/workflows/erlang.yml/badge.svg)](https://github.com/s3cur3/dockerexec/actions/workflows/erlang.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/dockerexec.svg)](https://hex.pm/packages/dockerexec)\n[![Hex.pm](https://img.shields.io/hexpm/dt/dockerexec.svg)](https://hex.pm/packages/dockerexec)\n\nThis is a fork of [erlexec](https://github.com/saleyn/erlexec) designed to be used within Docker.\nIt has two primary philosophical differences from erlexec:\n\n1. It allows execution as root without needing `sudo` (since many Docker configurations\n   run the app as root, and may not even ship with the `/usr/bin/sudo` executable)\n2. It removes the requirement for the `SHELL` environment variable to be set\n\nWhile neither of these requirements are particularly burdensome for applications incorporating\nerlexec directly into their package, they represent a bit of a non-starter for libraries\nthat want to depend on erlexec. Nobody wants to have to dig into their Docker configuration\nto install a third-party library... they want to just add the dependency to their `mix.exs`\nor `rebar.config` and be done with it.","ref":"readme.html"},{"type":"extras","title":"USAGE ## - Overview","doc":"#","ref":"readme.html#usage"},{"type":"extras","title":"Erlang: import as a dependency ### - Overview","doc":"- Add dependency in `rebar.config`:\n```erlang\n{deps,\n [% ...\n  {dockerexec, \"~> 2.0\"}\n  ]}.\n```\n\n- Include in your `*.app.src`:\n```erlang\n{applications,\n   [kernel,\n    stdlib,\n    % ...\n    dockerexec\n   ]}\n```\n\n#","ref":"readme.html#erlang-import-as-a-dependency"},{"type":"extras","title":"Elixir: import as a dependency ### - Overview","doc":"```elixir\ndefp deps do\n  [\n    # ...\n    {:dockerexec, \"~> 2.0\"}\n  ]\nend\n```","ref":"readme.html#elixir-import-as-a-dependency"},{"type":"extras","title":"License","doc":"BSD LICENSE\r\n===========\r\n\r\nCopyright (C) 2003 Serge Aleynikov  \r\n\r\nAll rights reserved.\r\n\r\nRedistribution and use in source and binary forms, with or without\r\nmodification, are permitted provided that the following conditions are met:\r\n\r\n  1. Redistributions of source code must retain the above copyright notice,\r\n     this list of conditions and the following disclaimer.\r\n\r\n  2. Redistributions in binary form must reproduce the above copyright \r\n     notice, this list of conditions and the following disclaimer in \r\n     the documentation and/or other materials provided with the distribution.\r\n\r\n  3. The names of the authors may not be used to endorse or promote products\r\n     derived from this software without specific prior written permission.\r\n\r\nTHIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,\r\nINCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND\r\nFITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL JCRAFT,\r\nINC. OR ANY CONTRIBUTORS TO THIS SOFTWARE BE LIABLE FOR ANY DIRECT, INDIRECT,\r\nINCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT\r\nLIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,\r\nOR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF\r\nLIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING\r\nNEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,\r\nEVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.","ref":"license.html"}],"content_type":"text/plain"}